* SLHAGetDecay.F
* searches a particular decay in the SLHA data structure
* last modified 24 Aug 04 th

#include "SLHAData.h"


	double precision function SLHAGetDecay(slhadata, parent_id,
     &    nchildren, child1_id, child2_id, child3_id, child4_id)
	implicit none
	double precision slhadata(*)
	integer parent_id
	integer nchildren, child1_id, child2_id, child3_id, child4_id

	integer decay, nextparent, nextchild

	SLHAGetDecay = invalid

	decay = 1
	do while( Decay_Id(decay) .ne. parent_id )
	  if( Decay(decay) .eq. invalid ) return
	  decay = decay + Decay_Next(decay)
	enddo

	if( nchildren .eq. 0 ) goto 1

	nextparent = decay + Decay_Next(decay)
	decay = decay + 2
	do while( decay .lt. nextparent )
	  nextchild = decay + Decay_Next(decay)
	  if( decay + nchildren + 1 .eq. nextchild ) then
	    if( Decay_Id(decay) .eq. child1_id ) then
	      if( decay + 2 .eq. nextchild ) goto 1
	      decay = decay + 1
	      if( Decay_Id(decay) .eq. child2_id ) then
	        if( decay + 2 .eq. nextchild ) goto 1
	        decay = decay + 1
	        if( Decay_Id(decay) .eq. child3_id ) then
	          if( decay + 2 .eq. nextchild ) goto 1
	          decay = decay + 1
	          if( Decay_Id(decay) .eq. child4_id ) then
	            if( decay + 2 .eq. nextchild ) goto 1
	          endif
	        endif
	      endif
	    endif
	  endif
	  decay = nextchild
	enddo

	return

1	SLHAGetDecay = Decay(decay + 1)
	end

