* SLHASetDecay.F
* adds/replaces a particular decay in the SLHA data structure
* last modified 25 Aug 04 th

#include "SLHAData.h"


	integer function SLHANewDecay(slhadata, width, parent_id)
	implicit none
	double precision slhadata(*), width
	integer parent_id

	integer decay, next

	SLHANewDecay = 0

	decay = 1
	do while( Decay(decay) .ne. invalid )
	  next = Decay_Next(decay)

* remove a previous instance of this decay, if any
	  if( Decay_Id(decay) .eq. parent_id ) then
	    do while( Decay(decay + next) .ne. invalid )
	      Decay(decay) = Decay(decay + next)
	      decay = decay + 1
	    enddo
	    goto 1
	  endif

	  decay = decay + next
	enddo

1	if( decay + 2 .ge. LengthDecay ) then
	  print *, "Out of memory in SLHANewDecay"
	  return
	endif

	Decay(decay) = Decay_Entry(parent_id, 2)
	Decay(decay + 1) = width
	SLHANewDecay = decay
	end


************************************************************************

	subroutine SLHAAddDecay(slhadata, width, parent,
     &    nchildren, child1_id, child2_id, child3_id, child4_id)
	implicit none
	double precision slhadata(*), width
	integer parent
	integer nchildren, child1_id, child2_id, child3_id, child4_id

	integer child

	if( parent .le. 0 ) return

	child = parent + Decay_Next(parent)

	if( child + nchildren + 1 .ge. LengthDecay ) then
	  print *, "Out of memory in SLHAAddDecay"
	  parent = 0
	  return
	endif

	if( nchildren .ge. 1 ) then
	  Decay(child) = Decay_Entry(child1_id, nchildren + 1)
	  child = child + 1
	  if( nchildren .ge. 2 ) then
	    Decay(child) = Decay_Entry(child2_id, nchildren + 1)
	    child = child + 1
	    if( nchildren .ge. 3 ) then
	      Decay(child) = Decay_Entry(child3_id, nchildren + 1)
	      child = child + 1
	      if( nchildren .ge. 4 ) then
	        Decay(child) = Decay_Entry(child4_id, nchildren + 1)
	        child = child + 1
	      endif
	    endif
	  endif
	endif

	Decay(child) = width
	Decay(parent) = Decay_Entry(Decay_Id(parent), child - parent + 1)
	end


