* SLHAWrite.F
* write a file in SUSY Les Houches Accord format (hep-ph/0311123)
* last modified 26 Aug 04 th

#include "PDG.h"
#include "SLHAData.h"


	subroutine SLHAWrite(error, slhadata,
     &    program, version, filename)
	implicit none
	integer error
	double precision slhadata(*)
	character*(*) program, version, filename

	integer lnblnk
	logical SLHAExist
	external lnblnk, SLHAExist

	integer i, j, n, decay, next, p0, p, id(10)
	character*(11*PDGLen) decay_name

	open(10, file=filename, status="unknown", err=97)

	error = 0

100	format("BLOCK ",A)
101	format("BLOCK ",A," Q=",E16.8)
201	format(I10,3x,1P,E16.8,0P,"   # ",A)
202	format(I6,I4,3x,1P,E16.8,0P,"   # ",A,"(",I1,",",I1,")")
203	format(I6,I4,3x,1P,E16.8,0P,"   # ",A)
204	format(13x,1P,E16.8,0P,"   # ",A)
300	format("DECAY",I10,3x,1P,E16.8,0P,"   # ",A)
301	format(3x,1P,E16.8,0P,I4,$,10I10)
302	format("   # ",A)
400	format(I10,5x,A)

	write(10, 100) "SPINFO"
	write(10, 400) 1, program
	write(10, 400) 2, version

#define Var(i,val,name) \
if( val .ne. invalid ) write(10,201) i, val, name

#define Array(i,j,val,name) \
if( val(i,j) .ne. invalid ) write(10,202) i,j, val(i,j), name, i,j

#define Element(i,j,val,name) \
if( val .ne. invalid ) write(10,203) i,j, val, name

#define Number(val,name) \
if( val .ne. invalid ) write(10,204) val, name

	if( SLHAExist(BlockModSel(1), LengthModSel) ) then
	  write(10, 100) "MODSEL"
	  Var(1, ModSel_Model,    "Model")
	  Var(3, ModSel_Content,  "Content")
	  Var(11, ModSel_GridPts, "GridPts")
	  Var(12, ModSel_Qmax,    "Qmax")
	  do i = 1, 5
	    Var(21, ModSel_PDG(i), "Particle")
	  enddo
	endif

	if( SLHAExist(BlockSMInputs(1), LengthSMInputs) ) then
	  write(10, 100) "SMINPUTS"
	  Var(1, SMInputs_AlfaMZ,  "AlfaMZ")
	  Var(2, SMInputs_GF,      "GF")
	  Var(3, SMInputs_AlfasMZ, "AlfasMZ")
	  Var(4, SMInputs_MZ,      "MZ")
	  Var(5, SMInputs_Mb,      "Mb")
	  Var(6, SMInputs_Mt,      "Mt")
	  Var(7, SMInputs_Mtau,    "Mtau")
	endif

	if( SLHAExist(BlockMinPar(1), LengthMinPar) ) then
	  write(10, 100) "MINPAR"
	  Var(0, MinPar_Q,       "Q")
	  Var(1, MinPar_M0,      "M0")
	  Var(2, MinPar_M12,     "M12")
	  Var(3, MinPar_TB,      "TB")
	  Var(4, MinPar_signMUE, "signMUE")
	  Var(5, MinPar_A,       "A")
	  Var(6, MinPar_cgrav,   "cgrav")
	endif

	if( SLHAExist(BlockExtPar(1), LengthExtPar) ) then
	  write(10, 100) "EXTPAR"
	  Var( 0, ExtPar_Q,      "Q")
	  Var( 1, ExtPar_M1,     "M1")
	  Var( 2, ExtPar_M2,     "M2")
	  Var( 3, ExtPar_M3,     "M3")
	  Var(11, ExtPar_At,     "At")
	  Var(12, ExtPar_Ab,     "Ab")
	  Var(13, ExtPar_Atau,   "Atau")
	  Var(21, ExtPar_MHd2,   "MHd2")
	  Var(22, ExtPar_MHu2,   "MHu2")
	  Var(23, ExtPar_MUE,    "MUE")
	  Var(24, ExtPar_MA02,   "MA02")
	  Var(25, ExtPar_TB,     "TB")
	  Var(31, ExtPar_MSL(1), "MSL(1)")
	  Var(32, ExtPar_MSL(2), "MSL(2)")
	  Var(33, ExtPar_MSL(3), "MSL(3)")
	  Var(34, ExtPar_MSE(1), "MSE(1)")
	  Var(35, ExtPar_MSE(2), "MSE(2)")
	  Var(36, ExtPar_MSE(3), "MSE(3)")
	  Var(41, ExtPar_MSQ(1), "MSQ(1)")
	  Var(42, ExtPar_MSQ(2), "MSQ(2)")
	  Var(43, ExtPar_MSQ(3), "MSQ(3)")
	  Var(44, ExtPar_MSU(1), "MSU(1)")
	  Var(45, ExtPar_MSU(2), "MSU(2)")
	  Var(46, ExtPar_MSU(3), "MSU(3)")
	  Var(47, ExtPar_MSD(1), "MSD(1)")
	  Var(48, ExtPar_MSD(2), "MSD(2)")
	  Var(49, ExtPar_MSD(3), "MSD(3)")
	  Var(51, ExtPar_N5(1),  "N5(1)")
	  Var(52, ExtPar_N5(2),  "N5(2)")
	  Var(53, ExtPar_N5(3),  "N5(3)")
	endif

	if( SLHAExist(BlockMass(1), LengthMass) ) then
	  write(10, 100) "MASS"
	  Var(PDG_nu_e,        Mass_Mf(1,1),    "Mf(1,1)")
	  Var(PDG_electron,    Mass_Mf(2,1),    "Mf(2,1)")
	  Var(PDG_up,          Mass_Mf(3,1),    "Mf(3,1)")
	  Var(PDG_down,        Mass_Mf(4,1),    "Mf(4,1)")
	  Var(PDG_nu_mu,       Mass_Mf(1,2),    "Mf(1,2)")
	  Var(PDG_muon,        Mass_Mf(2,2),    "Mf(2,2)")
	  Var(PDG_charm,       Mass_Mf(3,2),    "Mf(3,2)")
	  Var(PDG_strange,     Mass_Mf(4,2),    "Mf(4,2)")
	  Var(PDG_nu_tau,      Mass_Mf(1,3),    "Mf(1,3)")
	  Var(PDG_tau,         Mass_Mf(2,3),    "Mf(2,3)")
	  Var(PDG_top,         Mass_Mf(3,3),    "Mf(3,3)")
	  Var(PDG_bottom,      Mass_Mf(4,3),    "Mf(4,3)")
	  Var(PDG_snu_e1,      Mass_MSf(1,1,1), "MSf(1,1,1)")
	  Var(PDG_snu_e2,      Mass_MSf(2,1,1), "MSf(2,1,1)")
	  Var(PDG_selectron1,  Mass_MSf(1,2,1), "MSf(1,2,1)")
	  Var(PDG_selectron2,  Mass_MSf(2,2,1), "MSf(2,2,1)")
	  Var(PDG_sup1,        Mass_MSf(1,3,1), "MSf(1,3,1)")
	  Var(PDG_sup2,        Mass_MSf(2,3,1), "MSf(2,3,1)")
	  Var(PDG_sdown1,      Mass_MSf(1,4,1), "MSf(1,4,1)")
	  Var(PDG_sdown2,      Mass_MSf(2,4,1), "MSf(2,4,1)")
	  Var(PDG_snu_mu1,     Mass_MSf(1,1,2), "MSf(1,1,2)")
	  Var(PDG_snu_mu2,     Mass_MSf(2,1,2), "MSf(2,1,2)")
	  Var(PDG_smuon1,      Mass_MSf(1,2,2), "MSf(1,2,2)")
	  Var(PDG_smuon2,      Mass_MSf(2,2,2), "MSf(2,2,2)")
	  Var(PDG_scharm1,     Mass_MSf(1,3,2), "MSf(1,3,2)")
	  Var(PDG_scharm2,     Mass_MSf(2,3,2), "MSf(2,3,2)")
	  Var(PDG_sstrange1,   Mass_MSf(1,4,2), "MSf(1,4,2)")
	  Var(PDG_sstrange2,   Mass_MSf(2,4,2), "MSf(2,4,2)")
	  Var(PDG_snu_tau1,    Mass_MSf(1,1,3), "MSf(1,1,3)")
	  Var(PDG_snu_tau2,    Mass_MSf(2,1,3), "MSf(2,1,3)")
	  Var(PDG_stau1,       Mass_MSf(1,2,3), "MSf(1,2,3)")
	  Var(PDG_stau2,       Mass_MSf(2,2,3), "MSf(2,2,3)")
	  Var(PDG_stop1,       Mass_MSf(1,3,3), "MSf(1,3,3)")
	  Var(PDG_stop2,       Mass_MSf(2,3,3), "MSf(2,3,3)")
	  Var(PDG_sbottom1,    Mass_MSf(1,4,3), "MSf(1,4,3)")
	  Var(PDG_sbottom2,    Mass_MSf(2,4,3), "MSf(2,4,3)")
	  Var(PDG_Z,           Mass_MZ,         "MZ")
	  Var(PDG_W,           Mass_MW,         "MW")
	  Var(PDG_h0,          Mass_Mh0,        "Mh0")
	  Var(PDG_HH,          Mass_MHH,        "MHH")
	  Var(PDG_A0,          Mass_MA0,        "MA0")
	  Var(PDG_Hp,          Mass_MHp,        "MHp")
	  Var(PDG_neutralino1, Mass_MNeu(1),    "MNeu(1)")
	  Var(PDG_neutralino2, Mass_MNeu(2),    "MNeu(2)")
	  Var(PDG_neutralino3, Mass_MNeu(3),    "MNeu(3)")
	  Var(PDG_neutralino4, Mass_MNeu(4),    "MNeu(4)")
	  Var(PDG_chargino1,   Mass_MCha(1),    "MCha(1)")
	  Var(PDG_chargino2,   Mass_MCha(2),    "MCha(2)")
	  Var(PDG_gluino,      Mass_MGl,        "MGl")
	  Var(PDG_gravitino,   Mass_MGrav,      "MGrav")
	endif

	if( SLHAExist(BlockNMix(1), LengthNMix) ) then
	  write(10, 100) "NMIX"
	  do i = 1, 4
	    do j = 1, 4
	      Array(i,j, NMix_ZNeu, "ZNeu")
	    enddo
	  enddo
	endif

	if( SLHAExist(BlockUMix(1), LengthUMix) ) then
	  write(10, 100) "UMIX"
	  do i = 1, 2
	    do j = 1, 2
	      Array(i,j, UMix_UCha, "UCha")
	    enddo
	  enddo
	endif

	if( SLHAExist(BlockVMix(1), LengthVMix) ) then
	  write(10, 100) "VMIX"
	  do i = 1, 2
	    do j = 1, 2
	      Array(i,j, VMix_VCha, "VCha")
	    enddo
	  enddo
	endif

	if( SLHAExist(BlockStauMix(1), LengthStauMix) ) then
	  write(10, 100) "STAUMIX"
	  do i = 1, 2
	    do j = 1, 2
	      Array(i,j, StauMix_USf, "USf")
	    enddo
	  enddo
	endif

	if( SLHAExist(BlockStopMix(1), LengthStopMix) ) then
	  write(10, 100) "STOPMIX"
	  do i = 1, 2
	    do j = 1, 2
	      Array(i,j, StopMix_USf, "USf")
	    enddo
	  enddo
	endif

	if( SLHAExist(BlockSbotMix(1), LengthSbotMix) ) then
	  write(10, 100) "SBOTMIX"
	  do i = 1, 2
	    do j = 1, 2
	      Array(i,j, SbotMix_USf, "USf")
	    enddo
	  enddo
	endif

	if( SLHAExist(BlockAlpha(1), LengthAlpha) ) then
	  write(10, 100) "ALPHA"
	  Number(Alpha_Alpha, "Alpha")
	endif

	if( SLHAExist(BlockHMix(1), LengthHMix) ) then
	  write(10, 101) "HMIX", HMix_Q
	  Var(1, HMix_MUE,  "MUE")
	  Var(2, HMix_TB,   "TB")
	  Var(3, HMix_VEV,  "VEV")
	  Var(4, HMix_MA02, "MA02")
	endif

	if( SLHAExist(BlockGauge(1), LengthGauge) ) then
	  write(10, 101) "GAUGE", Gauge_Q
	  Var(1, Gauge_g1, "g1")
	  Var(2, Gauge_g2, "g2")
	  Var(3, Gauge_g3, "g3")
	endif

	if( SLHAExist(BlockMSoft(1), LengthMSoft) ) then
	  write(10, 101) "MSOFT", MSoft_Q
	  Var( 1, MSoft_M1,     "M1")
	  Var( 2, MSoft_M2,     "M2")
	  Var( 3, MSoft_M3,     "M3")
	  Var(21, MSoft_MHd2,   "MHd2")
	  Var(22, MSoft_MHu2,   "MHu2")
	  Var(31, MSoft_MSL(1), "MSL(1)")
	  Var(32, MSoft_MSL(2), "MSL(2)")
	  Var(33, MSoft_MSL(3), "MSL(3)")
	  Var(34, MSoft_MSE(1), "MSE(1)")
	  Var(35, MSoft_MSE(2), "MSE(2)")
	  Var(36, MSoft_MSE(3), "MSE(3)")
	  Var(41, MSoft_MSQ(1), "MSQ(1)")
	  Var(42, MSoft_MSQ(2), "MSQ(2)")
	  Var(43, MSoft_MSQ(3), "MSQ(3)")
	  Var(44, MSoft_MSU(1), "MSU(1)")
	  Var(45, MSoft_MSU(2), "MSU(2)")
	  Var(46, MSoft_MSU(3), "MSU(3)")
	  Var(47, MSoft_MSD(1), "MSD(1)")
	  Var(48, MSoft_MSD(2), "MSD(2)")
	  Var(49, MSoft_MSD(3), "MSD(3)")
	endif

	if( SLHAExist(BlockAe(1), LengthAe) ) then
	  write(10, 101) "AE", Ae_Q
	  Element(3,3, Ae_Atau, "Atau")
	endif

	if( SLHAExist(BlockAu(1), LengthAu) ) then
	  write(10, 101) "AU", Au_Q
	  Element(3,3, Au_At, "At")
	endif

	if( SLHAExist(BlockAd(1), LengthAd) ) then
	  write(10, 101) "AD", Ad_Q
	  Element(3,3, Ad_Ab, "Ab")
	endif

	if( SLHAExist(BlockYe(1), LengthYe) ) then
	  write(10, 101) "YE", Ye_Q
	  Element(3,3, Ye_Ytau, "Ytau")
	endif

	if( SLHAExist(BlockYu(1), LengthYu) ) then
	  write(10, 101) "YU", Yu_Q
	  Element(3,3, Yu_Yt, "Yt")
	endif

	if( SLHAExist(BlockYd(1), LengthYd) ) then
	  write(10, 101) "YD", Yd_Q
	  Element(3,3, Yd_Yb, "Yb")
	endif

	decay = 1
	do while( Decay(decay) .ne. invalid )
	  i = Decay_Id(decay)
	  call SLHAPDGName(i, decay_name)
	  p0 = lnblnk(decay_name(1:PDGLen))
	  write(10, 300) i, Decay(decay + 1), decay_name(1:p0)
	  next = decay + Decay_Next(decay)
	  decay = decay + 2

	  decay_name(p0+1:p0+4) = " ->"
	  p0 = p0 + 4

	  do while( decay .lt. next )
	    p = p0
	    n = Decay_Next(decay) - 1
	    do i = 1, n
	      id(i) = Decay_Id(decay)
	      decay_name(p:p) = ' '
	      call SLHAPDGName(id(i), decay_name(p+1:))
	      p = p + lnblnk(decay_name(p:p+PDGLen))
	      decay = decay + 1
	    enddo
	    write(10, 301) Decay(decay), n, (id(i), i = 1, n)
	    write(10, 302) decay_name(1:p)
	    decay = decay + 1
	  enddo
	enddo

	close(10)
	return

97	error = 1
	end

